From 36370bf30eb6dcff8abcc6f77a3d37c50ef886a6 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 13 2017 12:45:39 +0000
Subject: [PATCH 37/51] add @option decorator


This allows implementing linter methods which check if an optional block
exists. Later linter methods can have it as a prerequisite which allows
for less boiler plate code, especially in conjunction with the
@prerequisite_for decorator which is to follow.

---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index 98ddcdd..9d9555a 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -78,6 +78,7 @@ class LintLevel(object):
         return fn
 
 
+option = LintLevel("option", -1)
 info = LintLevel("info", 0)
 warning = LintLevel("warning", 1)
 error = LintLevel("error", 2)
@@ -176,20 +177,23 @@ class ModuleMDLinter(object):
 
         # ensure all lint methods are properly decorated
         assert all(
-            0 <= getattr(getattr(self, x), "lint_level", -1)
-              <= LintLevel.max_level
+            -1 <= getattr(getattr(self, x), "lint_level", -2)
+               <= LintLevel.max_level
             for x in lint_method_names), (
-                "All lint_*() methods must be decorated with one of the @info,"
-                " @warning, @error decorators.")
+                "All lint_*() methods must be decorated with one of the"
+                " @option, @info, @warning, @error decorators.")
 
         lint_methods = sorted(
             (y for y in (getattr(self, x) for x in lint_method_names)
-             if callable(y) and y.lint_level >= min_level),
+             if callable(y) and (y.lint_level == -1
+                                 or y.lint_level >= min_level)),
             key=lambda x: x.lint_order)
 
         # ensure all lint methods have a docstring
-        assert all(getattr(x, '__doc__', None) for x in lint_methods), (
-            """All lint_*() methods must have a docstring.""")
+        assert all(
+            getattr(x, '__doc__', None)
+            for x in lint_methods if x.lint_level >= 0), (
+                """All non-option lint_*() methods must have a docstring.""")
 
         flagged = []
         failed_or_skipped = set()
@@ -209,12 +213,14 @@ class ModuleMDLinter(object):
             try:
                 method()
             except LintCheckFailed as e:
-                try:
-                    lint_detail = method.lint_detail
-                except AttributeError:
-                    lint_detail = None
-                flagged.append((method.lint_level_name, inspect.getdoc(method),
-                                lint_detail, method.lint_guidelines_url, e))
+                if method.lint_level >= 0:
+                    try:
+                        lint_detail = method.lint_detail
+                    except AttributeError:
+                        lint_detail = None
+                    flagged.append((method.lint_level_name,
+                                    inspect.getdoc(method), lint_detail,
+                                    method.lint_guidelines_url, e))
                 failed_or_skipped.add(method.__name__)
 
         width, height = get_terminal_size()

